import java.io.FileWriter;
import java.io.IOException;

public class Main {

    public static void main(String args[]){
        Procedure mainProc =
            new Procedure("main",
                          new PrintIntStmt(
                                           new IntConstExpr(42)
                                           )
                          );
        if(args.length != 1){
            System.err.println("Usage: java -jar dist/Compiler.jar outputfile.s");
            System.exit(1);
        } else {
            try {
                FileWriter output = new FileWriter(args[0]);
                output.write(mainProc.generate());
                output.write(libraryCode);
                output.close();
            } catch(IOException e){
                System.err.println("I/O exception: " + e);
                System.exit(1);
            }
        }
    }

    private static String libraryCode =
        ".data\n" +
        "print_int_newline:\n" +
        ".asciiz \"\\n\"\n" +
        ".text\n" +
        "print_int:\n" +
        "li $v0, 1\n" +
        "syscall\n" +
        "la $a0, print_int_newline\n" +
        "li $v0, 4\n" +
        "syscall\n" +
        "jr $ra\n";
}
