public class PrintIntStmt extends Stmt {

    private Expr argument;

    public PrintIntStmt(Expr argument){
        this.argument = argument;
    }

    public String generate(){
        RegisterAndCode argRegAndCode = argument.generate();
        String argRegister = argRegAndCode.getRegister();
        String argCode = argRegAndCode.getCode();
        return argCode +
            "move $a0, " + argRegister + "\n" +
            "jal print_int\n";
    }
}
