public abstract class Expr {

    // When generating code for an expression we need to know two things:
    //   (a) What register will this code compute the value into?
    //   (b) What assembly code will compute the value into that register?
    // The RegisterAndCode object returned here packages these two together.

    public abstract RegisterAndCode generate();

}
