public class IntConstExpr extends Expr {

    private int value;

    public IntConstExpr(int value){
        this.value = value;
    }

    public RegisterAndCode generate(){
        String register = NameAllocator.getTempAllocator().next();
        String code = "li " + register + ", " + value + "\n";
        return new RegisterAndCode(register, code);
    }
}
