public class Procedure {

    private String name;
    private Stmt body;

    public Procedure(String name, Stmt body){
        // currently no provisions for parameters or return value
        this.name = name;
        this.body = body;
    }

    public String generate(){
        String bodyCode = body.generate();
        // for now, assume no $s registers are used
        String savingCode = "addu $sp, $sp, -4\n" +
            "sw $ra, 0($sp)\n";
        String restoringCode = "lw $ra, 0($sp)\n" +
            "addu $sp, $sp, 4\n";
        return name + ":\n" +
            savingCode +
            bodyCode +
            restoringCode +
            "j $ra\n";
    }
}
